function [ sorted ] = quicksort( unsorted )
%QUICKSORT Ordina il vettore con l'algoritmo QuickSort
% All'algoritmo viene passato il vettore non ordinato unsorted e, al termine
%, si ottiene il vettore ordinato sorted.
% Ad esempio, lanciando  quicksort([4 7 3 5 2])  dalla finestra dei
% comandi si otterr  ans = 2 3 4 5 7

% se il vettore  composto da un unico elemento o  vuoto, non  necessario
% effettuare alcun ordinamento e l'algoritmo termina
if length(unsorted)<2
    sorted = unsorted;
    return;

% in caso contrario, eseguo l'algoritmo visto a lezione    
else
    
    % inizializzo i due vettori right e left e le variabili r ed l, che
    % utilizzer successivamente,
    right=[]; left=[]; r=0; l=0;
    
    % utilizzo come pivot il primo elemento del vettore
    pivot=unsorted(1);
    
    % scorro il resto del vettore e confronto ogni elemento con il pivot
    for i=2:length(unsorted)

        % se l'elemento considerato  minore del pivot, lo copio nel
        % vettore left (contentente tutti gli elementi minori del pivot)
        if (unsorted(i)<pivot)
            % incremento l, utilizzato in questo caso come contatore del
            % numero di elementi aggiunti al vettore left
            l = l + 1;
            % aggiungo l'elemento individuato in coda al vettore left
            left(l) = unsorted(i);
        
        % se invece l'elemento considerato  maggior del pivot, lo copio nel
        % vettore right (contentente tutti gli elementi maggiori del pivot)
        else
            % incremento r, utilizzato in questo caso come contatore del
            % numero di elementi aggiunti al vettore right
            r = r + 1;
            % aggiungo l'elemento individuato in coda al vettore right
            right(r) = unsorted(i);
        end
    end
    
    % richiamo ricorsivamente quicksort, applicato in maniera distinta ai
    % vettori right e left
    left=quicksort(left);
    right=quicksort(right);
    
    % ricostruisco il vettore ordinato congiungendo i vari pezzi
    sorted=[left, pivot, right];
    return;
end